{$apptype windows}
unit Data;

uses
  GData, System.Drawing, OpenGl;

const
  //FloorW=1024*2;
  FloorW=128;

type
  Camera = record
    class X, Y, Z, dx, dy, dz: real;
    class RotX, RotY, drx, dry: Single;
    const Speed = 1.1;
    const Boost = 4;
  end;

function GetFloorBytes:array of byte;
begin
Result := new byte[FloorW*FloorW*3];
for i:integer := 0 to Result.Length-1 do
if true then
//Result[i] := 255 else
case i mod 3 of
0:Result[i] := Round(127.5+Rand(3.825*1));
1:Result[i] := Round(127.5+Rand(3.825*2));
2:Result[i] := Round(127.5+Rand(3.825*3));
end;

for i:integer := 0 to 2 do
  //Result[i] := 255
;for i:integer := 0 to FloorW*2*3-1 do
  //Result[i] := 255
;for i:integer := Result.Length-3 to Result.Length-1 do
  //Result[i] := 255
;
end;

var
  LMS:=false;
  LMP:Point;
  FloorTex:Texture;

procedure MouseStay;
begin
  
  if GetKeyState(192) shl 7 = 128 <> LMS then
  begin
  LMS := not LMS;
  if LMS then
  LMP := System.Windows.Forms.Cursor.Position;
  if LMS then
  System.Windows.Forms.Cursor.Position := new Point(Round(WW / 2), Round(WH / 2)) else
  System.Windows.Forms.Cursor.Position := LMP;
  end;
  if LMS then
  begin
  var MP := System.Windows.Forms.Cursor.Position;
  with Camera do
  begin
    RotX += (WW / 2 - MP.X) * 0.003;
    RotY -= (WH / 2 - MP.Y) * 0.003;
    
    while RotX > Pi do RotX -= 2 * Pi;
    while RotX < -Pi do RotX += 2 * Pi;
    
    if RotY > 1.57 then RotY := 1.57;
    if RotY < -1.57 then RotY := -1.57;
    
    drx *= 0.95;
    dry *= 0.95;
  end;
  
  var Speed := Camera.Speed;
  if GetKeyState(162) shr 7 = 1 then
  Speed *= Camera.Boost;
  
  if GetKeyState(32) div 128 = 1 then Camera.dY += Speed;
  if GetKeyState(160) div 128 = 1 then Camera.dY -= Speed;
  
  begin
    var dx := 0;
    var dz := 0;
    
    if GetKeyState(65) div 128 = 1 then dx += 1;
    if GetKeyState(68) div 128 = 1 then dx -= 1;
    
    if GetKeyState(87) div 128 = 1 then dz += 1;
    if GetKeyState(83) div 128 = 1 then dz -= 1;
    
    Camera.dX += (dx * Cos(Camera.RotX) + dz * Sin(Camera.RotX)) * Speed;
    Camera.dZ += (dz * Cos(Camera.RotX) - dx * Sin(Camera.RotX)) * Speed;
  end;
  
  System.Windows.Forms.Cursor.Position := new Point(Round(WW / 2), Round(WH / 2));
  end;
  
  Camera.X += Camera.dx;
  Camera.Y += Camera.dy;
  Camera.Z += Camera.dz;
  
  Camera.dx *= 0.85;
  Camera.dy *= 0.85;
  Camera.dz *= 0.85;
  
  gluLookAt(Camera.X, Camera.Y, Camera.Z,          Camera.X + Cos(Camera.RotY) * Sin(Camera.RotX), Camera.Y - Sin(Camera.RotY), Camera.Z + Cos(Camera.RotY) * Cos(Camera.RotX),          0, 1, 0);
end;

procedure OnMouseWheel(sender: System.Object; e: System.Windows.Forms.MouseEventArgs);
begin
  MW += Sign(e.Delta);
end;

procedure Redrawing;
begin
  try
    
    {$region Navigation}{
    {$endregion}
    
    {$region Calc}
    
    {$endregion}
    
    {$region Draw}
    if MF.Focused then
    begin
    
    glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
    
      {$region 3D}
      {$region 3D setup}
  glLoadIdentity;
  glEnable(GL_DEPTH_TEST);
  glPushMatrix;
  glMatrixMode(GL_PROJECTION);
  gluPerspective(45.0, WW / WH, 0.1, real.MaxValue);
    MouseStay;
      {$endregion}
    
    gr.Sphere(1,0,0,1,0,0,1020,20,20,20,2);
    FloorTex.Draw(GL_QUADS,new TexCoord[4](
    new TexCoord(0,0,-1000,0,-1000),
    new TexCoord(1,0,+1000,0,-1000),
    new TexCoord(1,1,+1000,0,+1000),
    new TexCoord(0,1,-1000,0,+1000)));
    
    glPopMatrix;
    
      {$endregion}
      {$region 2D}
      {$region 2D setup}
  glLoadIdentity;
  glDisable(GL_DEPTH_TEST);
  glPushMatrix;
  glMatrixMode(GL_MODELVIEW);
  gluOrtho2D(0, WW, WH, 0);
  glViewport(0, 0, WW, WH);
      {$endregion}
    
    if GetKeyState(112) shl 7 = 0 then
    begin
    gr.Rectangle(true,1,0,0,1,0,0,WW,70);
    end;
    
    if not LMS then
    begin
    var P := System.Windows.Forms.Cursor.Position;
    gr.Ellipse(true,0,0,0,1,P.X,P.Y,4,4);
    gr.Ellipse(true,1,1,1,1,P.X,P.Y,3,3);
    end;
    glPopMatrix;
    
      {$endregion}
    
    end;
    
    SwapBuffers(_hdc);
    {$endregion}
    
    if MF.Focused then
      MF.WindowState := System.Windows.Forms.FormWindowState.Maximized else
      //MF.WindowState := System.Windows.Forms.FormWindowState.Minimized;
    
  except
    on ee: system.Exception do
      writeln(ee);
  end;
end;

procedure FormInit;
begin
  FloorTex := new Texture(FloorW,FloorW,GetFloorBytes);
  FloorTex.Redraw;
end;

procedure Init;
begin
  MF := new System.Windows.Forms.Form;
  MF.WindowState := System.Windows.Forms.FormWindowState.Maximized;
  MF.FormBorderStyle := system.windows.forms.FormBorderStyle.None;
  MF.Controls.Add(new GraphField(0, 0, WW, WH, 16,FormInit, Redrawing));
  MF.Icon := Icon.FromHandle((new Bitmap(1,1)).GetHicon);
  MF.MouseWheel += OnMouseWheel;
  
  Camera.Z := -1550;
  Camera.Y := 880;
  Camera.RotY := 0.665;
  
  System.Windows.Forms.Cursor.Position := new Point(WW div 2, WH div 2);
  MF.Cursor.Dispose;
  system.windows.forms.Application.Run(MF);
end;

begin
  Init;
end.